# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, field_validator
from typing_extensions import Annotated, Self


class ConductPenaltyResult(BaseModel):
    """
    ConductPenaltyResult
    """  # noqa: E501

    penalty_type: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="Penalty type", alias="penaltyType"
    )
    penalty_value: Optional[StrictInt] = Field(default=None, description="Penalty value", alias="penaltyValue")
    __properties: ClassVar[List[str]] = ["penaltyType", "penaltyValue"]

    @field_validator("penalty_type")
    def penalty_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["FINANCIAL", "WEEKS", "GAMES", "MONTHS", "YEARS"]):
            raise ValueError("must be one of enum values ('FINANCIAL', 'WEEKS', 'GAMES', 'MONTHS', 'YEARS')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConductPenaltyResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if penalty_type (nullable) is None
        # and model_fields_set contains the field
        if self.penalty_type is None and "penalty_type" in self.model_fields_set:
            _dict["penaltyType"] = None

        # set to None if penalty_value (nullable) is None
        # and model_fields_set contains the field
        if self.penalty_value is None and "penalty_value" in self.model_fields_set:
            _dict["penaltyValue"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConductPenaltyResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({"penaltyType": obj.get("penaltyType"), "penaltyValue": obj.get("penaltyValue")})
        return _obj
