# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing_extensions import Annotated, Self


class FixturePersonStatisticsPostBody(BaseModel):
    """
    FixturePersonStatisticsPostBody
    """  # noqa: E501

    person_id: StrictStr = Field(description="The unique identifier of the person", alias="personId")
    entity_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the entity", alias="entityId"
    )
    fixture_id: StrictStr = Field(description="The unique identifier of the fixture", alias="fixtureId")
    statistics: Optional[Dict[str, Any]] = None
    bib: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="The number displayed on the jersey"
    )
    position: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Playing position"
    )
    did_not_play_reason: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="The reason the player didn't play", alias="didNotPlayReason"
    )
    starter: Optional[StrictBool] = None
    participated: Optional[StrictBool] = Field(
        default=None, description="Did the person actually participate in the the fixture"
    )
    is_player: Optional[StrictBool] = Field(default=None, description="Is this person a player", alias="isPlayer")
    is_team_official: Optional[StrictBool] = Field(
        default=None, description="Is this person an entity official", alias="isTeamOfficial"
    )
    __properties: ClassVar[List[str]] = [
        "personId",
        "entityId",
        "fixtureId",
        "statistics",
        "bib",
        "position",
        "didNotPlayReason",
        "starter",
        "participated",
        "isPlayer",
        "isTeamOfficial",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FixturePersonStatisticsPostBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if entity_id (nullable) is None
        # and model_fields_set contains the field
        if self.entity_id is None and "entity_id" in self.model_fields_set:
            _dict["entityId"] = None

        # set to None if bib (nullable) is None
        # and model_fields_set contains the field
        if self.bib is None and "bib" in self.model_fields_set:
            _dict["bib"] = None

        # set to None if position (nullable) is None
        # and model_fields_set contains the field
        if self.position is None and "position" in self.model_fields_set:
            _dict["position"] = None

        # set to None if did_not_play_reason (nullable) is None
        # and model_fields_set contains the field
        if self.did_not_play_reason is None and "did_not_play_reason" in self.model_fields_set:
            _dict["didNotPlayReason"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FixturePersonStatisticsPostBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "personId": obj.get("personId"),
                "entityId": obj.get("entityId"),
                "fixtureId": obj.get("fixtureId"),
                "statistics": obj.get("statistics"),
                "bib": obj.get("bib"),
                "position": obj.get("position"),
                "didNotPlayReason": obj.get("didNotPlayReason"),
                "starter": obj.get("starter"),
                "participated": obj.get("participated"),
                "isPlayer": obj.get("isPlayer"),
                "isTeamOfficial": obj.get("isTeamOfficial"),
            }
        )
        return _obj
