# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Annotated, Self


class FixtureVideosteamPostBody(BaseModel):
    """
    FixtureVideosteamPostBody
    """  # noqa: E501

    fixture_id: StrictStr = Field(description="The unique identifier of the fixture", alias="fixtureId")
    locale: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=5)]] = Field(
        default=None, description="The locale of the video"
    )
    platform_provider: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default="5STREAM", description="Video Provider platform >- `5STREAM` 5Stream ", alias="platformProvider"
    )
    __properties: ClassVar[List[str]] = ["fixtureId", "locale", "platformProvider"]

    @field_validator("locale")
    def locale_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[a-z]{2,2}-[A-Z]{2,2}$", value):
            raise ValueError(r"must validate the regular expression /^[a-z]{2,2}-[A-Z]{2,2}$/")
        return value

    @field_validator("platform_provider")
    def platform_provider_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["5STREAM"]):
            raise ValueError("must be one of enum values ('5STREAM')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FixtureVideosteamPostBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FixtureVideosteamPostBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "fixtureId": obj.get("fixtureId"),
                "locale": obj.get("locale"),
                "platformProvider": (
                    obj.get("platformProvider") if obj.get("platformProvider") is not None else "5STREAM"
                ),
            }
        )
        return _obj
