# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing_extensions import Self

from atriumsports.datacore.openapi.models.fixture_persons_model_person import FixturePersonsModelPerson
from atriumsports.datacore.openapi.models.fixture_progressions_model_season import FixtureProgressionsModelSeason
from atriumsports.datacore.openapi.models.season_person_placings_model_organization import (
    SeasonPersonPlacingsModelOrganization,
)


class SeasonPersonPlacingsModel(BaseModel):
    """
    SeasonPersonPlacingsModel
    """  # noqa: E501

    placing_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the SEASON PERSON placing", alias="placingId"
    )
    organization_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the organization", alias="organizationId"
    )
    organization: Optional[SeasonPersonPlacingsModelOrganization] = None
    season_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the season", alias="seasonId"
    )
    season: Optional[FixtureProgressionsModelSeason] = None
    person_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the person", alias="personId"
    )
    person: Optional[FixturePersonsModelPerson] = None
    result_place: Optional[StrictInt] = Field(default=None, description="Result place", alias="resultPlace")
    points: Optional[StrictInt] = Field(default=None, description="Points awarded")
    prize_money: Optional[StrictInt] = Field(default=None, description="Prize money awarded", alias="prizeMoney")
    updated: Optional[datetime] = Field(default=None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(default=None, description="Date/time added. In UTC")
    __properties: ClassVar[List[str]] = [
        "placingId",
        "organizationId",
        "organization",
        "seasonId",
        "season",
        "personId",
        "person",
        "resultPlace",
        "points",
        "prizeMoney",
        "updated",
        "added",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SeasonPersonPlacingsModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                "organization_id",
                "updated",
                "added",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of season
        if self.season:
            _dict["season"] = self.season.to_dict()
        # override the default output from pydantic by calling `to_dict()` of person
        if self.person:
            _dict["person"] = self.person.to_dict()
        # set to None if points (nullable) is None
        # and model_fields_set contains the field
        if self.points is None and "points" in self.model_fields_set:
            _dict["points"] = None

        # set to None if prize_money (nullable) is None
        # and model_fields_set contains the field
        if self.prize_money is None and "prize_money" in self.model_fields_set:
            _dict["prizeMoney"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SeasonPersonPlacingsModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "placingId": obj.get("placingId"),
                "organizationId": obj.get("organizationId"),
                "organization": (
                    SeasonPersonPlacingsModelOrganization.from_dict(obj["organization"])
                    if obj.get("organization") is not None
                    else None
                ),
                "seasonId": obj.get("seasonId"),
                "season": (
                    FixtureProgressionsModelSeason.from_dict(obj["season"]) if obj.get("season") is not None else None
                ),
                "personId": obj.get("personId"),
                "person": FixturePersonsModelPerson.from_dict(obj["person"]) if obj.get("person") is not None else None,
                "resultPlace": obj.get("resultPlace"),
                "points": obj.get("points"),
                "prizeMoney": obj.get("prizeMoney"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
            }
        )
        return _obj
