# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing_extensions import Annotated, Self

from atriumsports.datacore.openapi.models.standing_post_body_calculated_value import StandingPostBodyCalculatedValue
from atriumsports.datacore.openapi.models.standing_post_body_points_value import StandingPostBodyPointsValue


class StandingPutBody(BaseModel):
    """
    StandingPutBody
    """  # noqa: E501

    season_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the season", alias="seasonId"
    )
    entity_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the entity", alias="entityId"
    )
    division_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the division", alias="divisionId"
    )
    conference_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the conference", alias="conferenceId"
    )
    in_progress: Optional[StrictBool] = Field(
        default=None, description="Is the competitor in a current In-Progress fixture?", alias="inProgress"
    )
    live: Optional[StrictBool] = Field(default=None, description="Is this including live fixtures?")
    locked: Optional[StrictBool] = Field(default=None, description="Has the standing been locked (to prevent editing)?")
    grouping_base: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="Base grouping of standings row >- `OVERALL` Overall >- `ROUND` Round ",
        alias="groupingBase",
    )
    grouping_conference_division: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="Conference/Division grouping of standings row >- `CONFERENCE` Conference >- `DIVISION` Division >- `OVERALL` Overall ",
        alias="groupingConferenceDivision",
    )
    grouping_stage_pool: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="Stage/Pool grouping of standings row >- `OVERALL` Overall >- `STAGE` Stage >- `STAGEPOOL` Stage/Pool ",
        alias="groupingStagePool",
    )
    stage_code: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="A unique code for the stage. (Unique for season)", alias="stageCode"
    )
    pool_code: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="A unique code for the pool. (Unique for season)", alias="poolCode"
    )
    round_code: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="A unique code for the round. (Unique for season)", alias="roundCode"
    )
    round_number: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="The number given to the round", alias="roundNumber"
    )
    standing_configuration_id: Optional[StrictStr] = Field(
        default=None,
        description="The unique identifier of the ~standingConfiguration~",
        alias="standingConfigurationId",
    )
    fixture_type: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="Type of fixture >- `ALL_STAR` All Star >- `DEMONSTRATION` Demonstration >- `FINAL` Final >- `FRIENDLY` Friendly >- `PLAYOFF` Playoff >- `PRESEASON` Pre Season >- `REGULAR` Regular ",
        alias="fixtureType",
    )
    position: Optional[StrictInt] = Field(default=None, description="Position of the competitors standing record")
    secured_finals: Optional[StrictStr] = Field(
        default=None, description="Has competitor secured a finals position", alias="securedFinals"
    )
    points: Optional[Dict[str, StandingPostBodyPointsValue]] = Field(
        default=None, description="standings points fields"
    )
    calculated: Optional[Dict[str, StandingPostBodyCalculatedValue]] = Field(
        default=None, description="standings points fields"
    )
    external_id: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None, description="The Id of the data as set by the provider of the data", alias="externalId"
    )
    __properties: ClassVar[List[str]] = [
        "seasonId",
        "entityId",
        "divisionId",
        "conferenceId",
        "inProgress",
        "live",
        "locked",
        "groupingBase",
        "groupingConferenceDivision",
        "groupingStagePool",
        "stageCode",
        "poolCode",
        "roundCode",
        "roundNumber",
        "standingConfigurationId",
        "fixtureType",
        "position",
        "securedFinals",
        "points",
        "calculated",
        "externalId",
    ]

    @field_validator("grouping_base")
    def grouping_base_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["OVERALL", "ROUND"]):
            raise ValueError("must be one of enum values ('OVERALL', 'ROUND')")
        return value

    @field_validator("grouping_conference_division")
    def grouping_conference_division_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["OVERALL", "CONFERENCE", "DIVISION"]):
            raise ValueError("must be one of enum values ('OVERALL', 'CONFERENCE', 'DIVISION')")
        return value

    @field_validator("grouping_stage_pool")
    def grouping_stage_pool_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["OVERALL", "STAGE", "STAGEPOOL"]):
            raise ValueError("must be one of enum values ('OVERALL', 'STAGE', 'STAGEPOOL')")
        return value

    @field_validator("fixture_type")
    def fixture_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["ALL_STAR", "PRESEASON", "REGULAR", "FINAL", "PLAYOFF", "FRIENDLY", "DEMONSTRATION"]):
            raise ValueError(
                "must be one of enum values ('ALL_STAR', 'PRESEASON', 'REGULAR', 'FINAL', 'PLAYOFF', 'FRIENDLY', 'DEMONSTRATION')"
            )
        return value

    @field_validator("external_id")
    def external_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9A-Za-z\/_-]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9A-Za-z\/_-]+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandingPutBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in points (dict)
        _field_dict = {}
        if self.points:
            for _key_points in self.points:
                if self.points[_key_points]:
                    _field_dict[_key_points] = self.points[_key_points].to_dict()
            _dict["points"] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in calculated (dict)
        _field_dict = {}
        if self.calculated:
            for _key_calculated in self.calculated:
                if self.calculated[_key_calculated]:
                    _field_dict[_key_calculated] = self.calculated[_key_calculated].to_dict()
            _dict["calculated"] = _field_dict
        # set to None if division_id (nullable) is None
        # and model_fields_set contains the field
        if self.division_id is None and "division_id" in self.model_fields_set:
            _dict["divisionId"] = None

        # set to None if conference_id (nullable) is None
        # and model_fields_set contains the field
        if self.conference_id is None and "conference_id" in self.model_fields_set:
            _dict["conferenceId"] = None

        # set to None if stage_code (nullable) is None
        # and model_fields_set contains the field
        if self.stage_code is None and "stage_code" in self.model_fields_set:
            _dict["stageCode"] = None

        # set to None if pool_code (nullable) is None
        # and model_fields_set contains the field
        if self.pool_code is None and "pool_code" in self.model_fields_set:
            _dict["poolCode"] = None

        # set to None if round_code (nullable) is None
        # and model_fields_set contains the field
        if self.round_code is None and "round_code" in self.model_fields_set:
            _dict["roundCode"] = None

        # set to None if round_number (nullable) is None
        # and model_fields_set contains the field
        if self.round_number is None and "round_number" in self.model_fields_set:
            _dict["roundNumber"] = None

        # set to None if standing_configuration_id (nullable) is None
        # and model_fields_set contains the field
        if self.standing_configuration_id is None and "standing_configuration_id" in self.model_fields_set:
            _dict["standingConfigurationId"] = None

        # set to None if position (nullable) is None
        # and model_fields_set contains the field
        if self.position is None and "position" in self.model_fields_set:
            _dict["position"] = None

        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict["externalId"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandingPutBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "seasonId": obj.get("seasonId"),
                "entityId": obj.get("entityId"),
                "divisionId": obj.get("divisionId"),
                "conferenceId": obj.get("conferenceId"),
                "inProgress": obj.get("inProgress"),
                "live": obj.get("live"),
                "locked": obj.get("locked"),
                "groupingBase": obj.get("groupingBase"),
                "groupingConferenceDivision": obj.get("groupingConferenceDivision"),
                "groupingStagePool": obj.get("groupingStagePool"),
                "stageCode": obj.get("stageCode"),
                "poolCode": obj.get("poolCode"),
                "roundCode": obj.get("roundCode"),
                "roundNumber": obj.get("roundNumber"),
                "standingConfigurationId": obj.get("standingConfigurationId"),
                "fixtureType": obj.get("fixtureType"),
                "position": obj.get("position"),
                "securedFinals": obj.get("securedFinals"),
                "points": (
                    dict((_k, StandingPostBodyPointsValue.from_dict(_v)) for _k, _v in obj["points"].items())
                    if obj.get("points") is not None
                    else None
                ),
                "calculated": (
                    dict((_k, StandingPostBodyCalculatedValue.from_dict(_v)) for _k, _v in obj["calculated"].items())
                    if obj.get("calculated") is not None
                    else None
                ),
                "externalId": obj.get("externalId"),
            }
        )
        return _obj
