# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Annotated, Self


class UniformItemsPostBodyColors(BaseModel):
    """
    UniformItemsPostBodyColors
    """  # noqa: E501

    lettering: Optional[Annotated[str, Field(min_length=6, strict=True, max_length=6)]] = Field(
        default=None,
        description="Primary color of the Uniform Item Lettering.  Colors are a hexadecimal string `RRGGBB` with `RR`(red), `GG`(green) and `BB`(blue) representing the components of the colour. ",
    )
    primary: Optional[Annotated[str, Field(min_length=6, strict=True, max_length=6)]] = Field(
        default=None,
        description="Primary color of the uniform_items.  Colors are a hexadecimal string `RRGGBB` with `RR`(red), `GG`(green) and `BB`(blue) representing the components of the colour. ",
    )
    secondary: Optional[Annotated[str, Field(min_length=6, strict=True, max_length=6)]] = Field(
        default=None,
        description="Secondary color of the uniform_items.  Colors are a hexadecimal string `RRGGBB` with `RR`(red), `GG`(green) and `BB`(blue) representing the components of the colour. ",
    )
    tertiary: Optional[Annotated[str, Field(min_length=6, strict=True, max_length=6)]] = Field(
        default=None,
        description="Tertiary color of the uniform_items.  Colors are a hexadecimal string `RRGGBB` with `RR`(red), `GG`(green) and `BB`(blue) representing the components of the colour. ",
    )
    __properties: ClassVar[List[str]] = ["lettering", "primary", "secondary", "tertiary"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UniformItemsPostBodyColors from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if lettering (nullable) is None
        # and model_fields_set contains the field
        if self.lettering is None and "lettering" in self.model_fields_set:
            _dict["lettering"] = None

        # set to None if primary (nullable) is None
        # and model_fields_set contains the field
        if self.primary is None and "primary" in self.model_fields_set:
            _dict["primary"] = None

        # set to None if secondary (nullable) is None
        # and model_fields_set contains the field
        if self.secondary is None and "secondary" in self.model_fields_set:
            _dict["secondary"] = None

        # set to None if tertiary (nullable) is None
        # and model_fields_set contains the field
        if self.tertiary is None and "tertiary" in self.model_fields_set:
            _dict["tertiary"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UniformItemsPostBodyColors from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "lettering": obj.get("lettering"),
                "primary": obj.get("primary"),
                "secondary": obj.get("secondary"),
                "tertiary": obj.get("tertiary"),
            }
        )
        return _obj
